#include "precompile.h"

#include <f8/netmsghandler.h>

#include "longsession.h"
#include "kcpsession.h"

void LongSession::Init(f8::MsgHdr& hdr, const ss::SS_CMKcpHandshake& msg)
{
    kcp_session_ = std::make_shared<KcpSession>();
    kcp_session_->Init(hdr.socket_handle);
}

void LongSession::UnInit()
{
    kcp_session_->UnInit();
}

void LongSession::Update(long long tick)
{
    GetKcpSession()->Update(tick);
}

void LongSession::UpdatePing()
{
    last_ping_tick_ = a8::XGetTickCount();
}
